diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/spectrum/model/three-gpp-channel-model.cc ns-3.43/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.42/src/spectrum/model/three-gpp-channel-model.cc	2024-05-29 15:29:47.172073600 -0700
+++ ns-3.43/src/spectrum/model/three-gpp-channel-model.cc	2024-10-09 16:41:10.088656700 -0700
@@ -4,18 +4,7 @@
  * Copyright (c) 2015, NYU WIRELESS, Tandon School of Engineering,
  * New York University
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
@@ -33,6 +22,7 @@
 #include <ns3/simulator.h>
 
 #include <algorithm>
+#include <array>
 #include <map>
 #include <random>
 
@@ -48,7 +38,7 @@
 
 /// The ray offset angles within a cluster, given for rms angle spread normalized to 1.
 /// (Table 7.5-3)
-static const double offSetAlpha[20] = {
+static constexpr std::array<double, 20> offSetAlpha = {
     0.0447, -0.0447, 0.1413, -0.1413, 0.2492, -0.2492, 0.3715, -0.3715, 0.5129, -0.5129,
     0.6797, -0.6797, 0.8844, -0.8844, 1.1481, -1.1481, 1.5195, -1.5195, 2.1551, -2.1551,
 };
@@ -61,7 +51,7 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_RMa_LOS[7][7] = {
+static constexpr std::array<std::array<double, 7>, 7> sqrtC_RMa_LOS = {{
     {1, 0, 0, 0, 0, 0, 0},
     {0, 1, 0, 0, 0, 0, 0},
     {-0.5, 0, 0.866025, 0, 0, 0, 0},
@@ -69,7 +59,7 @@
     {0, 0, 0, 0, 1, 0, 0},
     {0.01, 0, -0.0519615, 0.73, -0.2, 0.651383, 0},
     {-0.17, -0.02, 0.21362, -0.14, 0.24, 0.142773, 0.909661},
-};
+}};
 
 /**
  * The square root matrix for <em>RMa NLOS</em>, which is generated using the
@@ -80,14 +70,14 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_RMa_NLOS[6][6] = {
+static constexpr std::array<std::array<double, 6>, 6> sqrtC_RMa_NLOS = {{
     {1, 0, 0, 0, 0, 0},
     {-0.5, 0.866025, 0, 0, 0, 0},
     {0.6, -0.11547, 0.791623, 0, 0, 0},
     {0, 0, 0, 1, 0, 0},
     {-0.04, -0.138564, 0.540662, -0.18, 0.809003, 0},
     {-0.25, -0.606218, -0.240013, 0.26, -0.231685, 0.625392},
-};
+}};
 
 /**
  * The square root matrix for <em>RMa O2I</em>, which is generated using the
@@ -97,14 +87,14 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_RMa_O2I[6][6] = {
+static constexpr std::array<std::array<double, 6>, 6> sqrtC_RMa_O2I = {{
     {1, 0, 0, 0, 0, 0},
     {0, 1, 0, 0, 0, 0},
     {0, 0, 1, 0, 0, 0},
     {0, 0, -0.7, 0.714143, 0, 0},
     {0, 0, 0.66, -0.123225, 0.741091, 0},
     {0, 0, 0.47, 0.152631, -0.393194, 0.775373},
-};
+}};
 
 /**
  * The square root matrix for <em>UMa LOS</em>, which is generated using the
@@ -114,7 +104,7 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_UMa_LOS[7][7] = {
+static constexpr std::array<std::array<double, 7>, 7> sqrtC_UMa_LOS = {{
     {1, 0, 0, 0, 0, 0, 0},
     {0, 1, 0, 0, 0, 0, 0},
     {-0.4, -0.4, 0.824621, 0, 0, 0, 0},
@@ -122,7 +112,7 @@
     {-0.5, -0.2, 0.630593, -0.484671, 0.278293, 0, 0},
     {0, 0, -0.242536, 0.672172, 0.642214, 0.27735, 0},
     {-0.8, 0, -0.388057, -0.367926, 0.238537, -3.58949e-15, 0.130931},
-};
+}};
 
 /**
  * The square root matrix for <em>UMa NLOS</em>, which is generated using the
@@ -133,14 +123,14 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_UMa_NLOS[6][6] = {
+static constexpr std::array<std::array<double, 6>, 6> sqrtC_UMa_NLOS = {{
     {1, 0, 0, 0, 0, 0},
     {-0.4, 0.916515, 0, 0, 0, 0},
     {-0.6, 0.174574, 0.78072, 0, 0, 0},
     {0, 0.654654, 0.365963, 0.661438, 0, 0},
     {0, -0.545545, 0.762422, 0.118114, 0.327327, 0},
     {-0.4, -0.174574, -0.396459, 0.392138, 0.49099, 0.507445},
-};
+}};
 
 /**
  * The square root matrix for <em>UMa O2I</em>, which is generated using the
@@ -150,15 +140,14 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_UMa_O2I[6][6] = {
+static constexpr std::array<std::array<double, 6>, 6> sqrtC_UMa_O2I = {{
     {1, 0, 0, 0, 0, 0},
     {-0.5, 0.866025, 0, 0, 0, 0},
     {0.2, 0.57735, 0.791623, 0, 0, 0},
     {0, 0.46188, -0.336861, 0.820482, 0, 0},
     {0, -0.69282, 0.252646, 0.493742, 0.460857, 0},
     {0, -0.23094, 0.16843, 0.808554, -0.220827, 0.464515},
-
-};
+}};
 
 /**
  * The square root matrix for <em>UMi LOS</em>, which is generated using the
@@ -168,7 +157,7 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_UMi_LOS[7][7] = {
+static constexpr std::array<std::array<double, 7>, 7> sqrtC_UMi_LOS = {{
     {1, 0, 0, 0, 0, 0, 0},
     {0.5, 0.866025, 0, 0, 0, 0, 0},
     {-0.4, -0.57735, 0.711805, 0, 0, 0, 0},
@@ -176,7 +165,7 @@
     {-0.4, -0.11547, 0.805464, -0.23482, 0.350363, 0, 0},
     {0, 0, 0, 0.688514, 0.461454, 0.559471, 0},
     {0, 0, 0.280976, 0.231921, -0.490509, 0.11916, 0.782603},
-};
+}};
 
 /**
  * The square root matrix for <em>UMi NLOS</em>, which is generated using the
@@ -187,14 +176,14 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_UMi_NLOS[6][6] = {
+static constexpr std::array<std::array<double, 6>, 6> sqrtC_UMi_NLOS = {{
     {1, 0, 0, 0, 0, 0},
     {-0.7, 0.714143, 0, 0, 0, 0},
     {0, 0, 1, 0, 0, 0},
     {-0.4, 0.168034, 0, 0.90098, 0, 0},
     {0, -0.70014, 0.5, 0.130577, 0.4927, 0},
     {0, 0, 0.5, 0.221981, -0.566238, 0.616522},
-};
+}};
 
 /**
  * The square root matrix for <em>UMi O2I</em>, which is generated using the
@@ -204,14 +193,14 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_UMi_O2I[6][6] = {
+static constexpr std::array<std::array<double, 6>, 6> sqrtC_UMi_O2I = {{
     {1, 0, 0, 0, 0, 0},
     {-0.5, 0.866025, 0, 0, 0, 0},
     {0.2, 0.57735, 0.791623, 0, 0, 0},
     {0, 0.46188, -0.336861, 0.820482, 0, 0},
     {0, -0.69282, 0.252646, 0.493742, 0.460857, 0},
     {0, -0.23094, 0.16843, 0.808554, -0.220827, 0.464515},
-};
+}};
 
 /**
  * The square root matrix for <em>Indoor-Office LOS</em>, which is generated
@@ -221,7 +210,7 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_office_LOS[7][7] = {
+static constexpr std::array<std::array<double, 7>, 7> sqrtC_office_LOS = {{
     {1, 0, 0, 0, 0, 0, 0},
     {0.5, 0.866025, 0, 0, 0, 0, 0},
     {-0.8, -0.11547, 0.588784, 0, 0, 0, 0},
@@ -229,7 +218,7 @@
     {-0.5, 0.288675, 0.73598, -0.348236, 0.0610847, 0, 0},
     {0.2, -0.11547, 0.418943, 0.541106, 0.219905, 0.655744, 0},
     {0.3, -0.057735, 0.73598, -0.348236, 0.0610847, -0.304997, 0.383375},
-};
+}};
 
 /**
  * The square root matrix for <em>Indoor-Office NLOS</em>, which is generated
@@ -240,14 +229,14 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_office_NLOS[6][6] = {
+static constexpr std::array<std::array<double, 6>, 6> sqrtC_office_NLOS = {{
     {1, 0, 0, 0, 0, 0},
     {-0.5, 0.866025, 0, 0, 0, 0},
     {0, 0.46188, 0.886942, 0, 0, 0},
     {-0.4, -0.23094, 0.120263, 0.878751, 0, 0},
     {0, -0.311769, 0.55697, -0.249198, 0.728344, 0},
     {0, -0.069282, 0.295397, 0.430696, 0.468462, 0.709214},
-};
+}};
 
 /**
  * The square root matrix for <em>NTN Dense Urban LOS</em>, which is generated
@@ -257,7 +246,7 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_NTN_DenseUrban_LOS[7][7] = {
+static constexpr std::array<std::array<double, 7>, 7> sqrtC_NTN_DenseUrban_LOS = {{
     {1, 0, 0, 0, 0, 0, 0},
     {0, 1, 0, 0, 0, 0, 0},
     {-0.4, -0.4, 0.824621, 0, 0, 0, 0},
@@ -265,7 +254,7 @@
     {-0.5, -0.2, 0.630593, -0.484671, 0.278293, 0, 0},
     {0, 0, -0.242536, 0.672172, 0.642214, 0.27735, 0},
     {-0.8, 0, -0.388057, -0.367926, 0.238537, -4.09997e-15, 0.130931},
-};
+}};
 
 /**
  * The square root matrix for <em>NTN Dense Urban NLOS</em>, which is generated
@@ -275,14 +264,14 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_NTN_DenseUrban_NLOS[6][6] = {
+static constexpr std::array<std::array<double, 6>, 6> sqrtC_NTN_DenseUrban_NLOS = {{
     {1, 0, 0, 0, 0, 0},
     {-0.4, 0.916515, 0, 0, 0, 0},
     {-0.6, 0.174574, 0.78072, 0, 0, 0},
     {0, 0.654654, 0.365963, 0.661438, 0, 0},
     {0, -0.545545, 0.762422, 0.118114, 0.327327, 0},
     {-0.4, -0.174574, -0.396459, 0.392138, 0.49099, 0.507445},
-};
+}};
 
 /**
  * The square root matrix for <em>NTN Urban LOS</em>, which is generated
@@ -292,7 +281,7 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_NTN_Urban_LOS[7][7] = {
+static constexpr std::array<std::array<double, 7>, 7> sqrtC_NTN_Urban_LOS = {{
     {1, 0, 0, 0, 0, 0, 0},
     {0, 1, 0, 0, 0, 0, 0},
     {-0.4, -0.4, 0.824621, 0, 0, 0, 0},
@@ -300,7 +289,7 @@
     {-0.5, -0.2, 0.630593, -0.484671, 0.278293, 0, 0},
     {0, 0, -0.242536, 0.672172, 0.642214, 0.27735, 0},
     {-0.8, 0, -0.388057, -0.367926, 0.238537, -4.09997e-15, 0.130931},
-};
+}};
 
 /**
  * The square root matrix for <em>NTN Urban NLOS</em>, which is generated
@@ -312,88 +301,88 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const std::map<int, std::vector<std::vector<double>>> sqrtC_NTN_Urban_NLOS{
+static const std::map<int, std::array<std::array<double, 6>, 6>> sqrtC_NTN_Urban_NLOS{
     {10,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.21, 0.977701, 0, 0, 0, 0},
          {-0.48, 0.459445, 0.747335, 0, 0, 0},
          {-0.05, 0.377927, 0.28416, 0.879729, 0, 0},
          {-0.02, 0.691213, 0.258017, 0.073265, 0.670734, 0},
          {-0.31, -0.00521632, -0.115615, 0.0788023, 0.00218104, 0.940368},
-     }},
+     }}},
     {20,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.25, 0.968246, 0, 0, 0, 0},
          {-0.52, 0.35115, 0.778648, 0, 0, 0},
          {-0.04, 0.371806, 0.345008, 0.860889, 0, 0},
          {0, 0.743613, 0.281102, 0.0424415, 0.605161, 0},
          {-0.32, 0.0206559, -0.0689057, 0.154832, 0.061865, 0.929852},
-     }},
+     }}},
     {30,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.21, 0.977701, 0, 0, 0, 0},
          {-0.52, 0.450853, 0.725487, 0, 0, 0},
          {-0.04, 0.288023, 0.260989, 0.920504, 0, 0},
          {0.01, 0.697657, 0.386856, 0.0418183, 0.601472, 0},
          {-0.33, 0.0416283, -0.0694268, 0.166137, 0.139937, 0.915075},
-     }},
+     }}},
     {40,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.26, 0.965609, 0, 0, 0, 0},
          {-0.53, 0.395813, 0.749955, 0, 0, 0},
          {-0.04, 0.299914, 0.320139, 0.897754, 0, 0},
          {0.01, 0.696556, 0.372815, 0.0580784, 0.610202, 0},
          {-0.33, 0.0457742, -0.0173584, 0.154417, 0.129332, 0.920941},
-     }},
+     }}},
     {50,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.25, 0.968246, 0, 0, 0, 0},
          {-0.57, 0.420864, 0.705672, 0, 0, 0},
          {-0.03, 0.229797, 0.235501, 0.943839, 0, 0},
          {0.03, 0.679063, 0.384466, 0.0681379, 0.6209, 0},
          {-0.41, -0.147173, -0.229228, 0.270707, 0.293002, 0.773668},
-     }},
+     }}},
     {60,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.2, 0.979796, 0, 0, 0, 0},
          {-0.53, 0.473568, 0.703444, 0, 0, 0},
          {-0.05, 0.204124, 0.109225, 0.971547, 0, 0},
          {0.03, 0.68994, 0.411073, 0.0676935, 0.591202, 0},
          {-0.4, -0.224537, -0.292371, 0.275609, 0.301835, 0.732828},
-     }},
+     }}},
     {70,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.19, 0.981784, 0, 0, 0, 0},
          {-0.5, 0.524555, 0.689088, 0, 0, 0},
          {-0.03, 0.228462, 0.18163, 0.955989, 0, 0},
          {-0.02, 0.637818, 0.428725, 0.00608114, 0.639489, 0},
          {-0.36, -0.18171, -0.282523, 0.106726, 0.123808, 0.854894},
-     }},
+     }}},
     {80,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.2, 0.979796, 0, 0, 0, 0},
          {-0.49, 0.502145, 0.712566, 0, 0, 0},
          {-0.01, 0.232702, 0.151916, 0.960558, 0, 0},
          {-0.05, 0.612372, 0.376106, 0.0206792, 0.693265, 0},
          {-0.37, -0.320475, -0.365405, -0.00376264, 0.0364343, 0.790907},
-     }},
+     }}},
     {90,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.19, 0.981784, 0, 0, 0, 0},
          {-0.38, 0.58852, 0.713613, 0, 0, 0},
          {-0.03, 0.360874, 0.12082, 0.924269, 0, 0},
          {-0.12, 0.526796, 0.34244, 0.0594196, 0.766348, 0},
          {-0.33, -0.257389, -0.24372, -0.257035, -0.176521, 0.817451},
-     }},
+     }}},
 };
 
 /**
@@ -404,7 +393,7 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_NTN_Suburban_LOS[7][7] = {
+static constexpr std::array<std::array<double, 7>, 7> sqrtC_NTN_Suburban_LOS = {{
     {1, 0, 0, 0, 0, 0, 0},
     {0, 1, 0, 0, 0, 0, 0},
     {-0.4, -0.4, 0.824621, 0, 0, 0, 0},
@@ -412,7 +401,7 @@
     {-0.5, -0.2, 0.630593, -0.484671, 0.278293, 0, 0},
     {0, 0, -0.242536, 0.672172, 0.642214, 0.27735, 0},
     {-0.8, 0, -0.388057, -0.367926, 0.238537, -4.09997e-15, 0.130931},
-};
+}};
 
 /**
  * The square root matrix for <em>NTN Suburban NLOS</em>, which is generated
@@ -422,14 +411,14 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_NTN_Suburban_NLOS[6][6] = {
+static constexpr std::array<std::array<double, 6>, 6> sqrtC_NTN_Suburban_NLOS = {{
     {1, 0, 0, 0, 0, 0},
     {-0.4, 0.916515, 0, 0, 0, 0},
     {-0.6, 0.174574, 0.78072, 0, 0, 0},
     {0, 0.654654, 0.365963, 0.661438, 0, 0},
     {0, -0.545545, 0.762422, 0.118114, 0.327327, 0},
     {-0.4, -0.174574, -0.396459, 0.392138, 0.49099, 0.507445},
-};
+}};
 
 /**
  * The square root matrix for <em>NTN Rural LOS</em>, which is generated
@@ -439,7 +428,7 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const double sqrtC_NTN_Rural_LOS[7][7] = {
+static constexpr std::array<std::array<double, 7>, 7> sqrtC_NTN_Rural_LOS = {{
     {1, 0, 0, 0, 0, 0, 0},
     {0, 1, 0, 0, 0, 0, 0},
     {-0.5, 0, 0.866025, 0, 0, 0, 0},
@@ -447,7 +436,7 @@
     {0, 0, 0, 0, 1, 0, 0},
     {0.01, 0, -0.0519615, 0.73, -0.2, 0.651383, 0},
     {-0.17, -0.02, 0.21362, -0.14, 0.24, 0.142773, 0.909661},
-};
+}};
 
 /**
  * The square root matrix for <em>NTN Rural NLOS S Band</em>, which is generated
@@ -459,88 +448,88 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const std::map<int, std::vector<std::vector<double>>> sqrtC_NTN_Rural_NLOS_S{
+static const std::map<int, std::array<std::array<double, 6>, 6>> sqrtC_NTN_Rural_NLOS_S{
     {10,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.36, 0.932952, 0, 0, 0, 0},
          {0.45, 0.516639, 0.728412, 0, 0, 0},
          {0.02, 0.329277, 0.371881, 0.867687, 0, 0},
          {-0.06, 0.59853, 0.436258, -0.0324062, 0.668424, 0},
          {-0.07, 0.0373009, 0.305087, -0.0280496, -0.225204, 0.921481},
-     }},
+     }}},
     {20,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.39, 0.920815, 0, 0, 0, 0},
          {0.52, 0.426579, 0.740021, 0, 0, 0},
          {0, 0.347518, -0.0381664, 0.936896, 0, 0},
          {-0.04, 0.710675, 0.172483, 0.116993, 0.670748, 0},
          {-0.17, -0.0394216, 0.115154, 0.243458, -0.0702635, 0.944498},
-     }},
+     }}},
     {30,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.41, 0.912086, 0, 0, 0, 0},
          {0.54, 0.49491, 0.680782, 0, 0, 0},
          {0, 0.350844, -0.152231, 0.923977, 0, 0},
          {-0.04, 0.694672, 0.0702137, 0.0832998, 0.709903, 0},
          {-0.19, -0.0854087, 0.0805978, 0.283811, -0.137441, 0.922318},
-     }},
+     }}},
     {40,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.37, 0.929032, 0, 0, 0, 0},
          {0.53, 0.480177, 0.698949, 0, 0, 0},
          {0.01, 0.434538, 0.00864797, 0.900556, 0, 0},
          {-0.05, 0.765851, -0.0303947, 0.0421641, 0.63896, 0},
          {-0.17, -0.16458, 0.0989022, 0.158081, -0.150425, 0.941602},
-     }},
+     }}},
     {50,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.4, 0.916515, 0, 0, 0, 0},
          {0.55, 0.403703, 0.731111, 0, 0, 0},
          {0.02, 0.499719, -0.0721341, 0.862947, 0, 0},
          {-0.06, 0.835775, -0.156481, 0.0373835, 0.521534, 0},
          {-0.19, -0.301141, 0.145082, 0.144564, -0.0238067, 0.911427},
-     }},
+     }}},
     {60,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.41, 0.912086, 0, 0, 0, 0},
          {0.56, 0.339442, 0.755764, 0, 0, 0},
          {0.02, 0.436582, -0.0256617, 0.899076, 0, 0},
          {-0.07, 0.856608, -0.12116, 0.0715303, 0.491453, 0},
          {-0.2, -0.331109, 0.15136, 0.036082, 0.031313, 0.908391},
-     }},
+     }}},
     {70,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.4, 0.916515, 0, 0, 0, 0},
          {0.56, 0.386246, 0.732949, 0, 0, 0},
          {0.04, 0.573913, -0.0601289, 0.815726, 0, 0},
          {-0.11, 0.813953, -0.0720183, 0.0281118, 0.565158, 0},
          {-0.19, -0.432071, 0.236423, -0.0247788, -0.0557206, 0.847113},
-     }},
+     }}},
     {80,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.46, 0.887919, 0, 0, 0, 0},
          {0.58, 0.469412, 0.665772, 0, 0, 0},
          {0.01, 0.309262, -0.286842, 0.90663, 0, 0},
          {-0.05, 0.762457, -0.268721, -0.0467443, 0.584605, 0},
          {-0.23, -0.580909, 0.399665, 0.0403629, 0.326208, 0.584698},
-     }},
+     }}},
     {90,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.3, 0.953939, 0, 0, 0, 0},
          {0.47, 0.81871, 0.329868, 0, 0, 0},
          {0.06, 0.0712834, -0.595875, 0.797654, 0, 0},
          {-0.1, 0.408831, -0.0233859, 0.0412736, 0.905873, 0},
          {-0.13, -0.407783, 0.439436, -0.0768289, -0.212875, 0.756631},
-     }},
+     }}},
 };
 
 /**
@@ -554,88 +543,88 @@
  * The Matlab file to generate the matrices can be found in
  * https://github.com/nyuwireless-unipd/ns3-mmwave/blob/master/src/mmwave/model/BeamFormingMatrix/SqrtMatrix.m
  */
-static const std::map<int, std::vector<std::vector<double>>> sqrtC_NTN_Rural_NLOS_Ka{
+static const std::map<int, std::array<std::array<double, 6>, 6>> sqrtC_NTN_Rural_NLOS_Ka{
     {10,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.36, 0.932952, 0, 0, 0, 0},
          {0.45, 0.527358, 0.72069, 0, 0, 0},
          {0.02, 0.350715, 0.355282, 0.866241, 0, 0},
          {-0.07, 0.562515, 0.478504, 0.0162932, 0.670406, 0},
          {-0.06, 0.0411597, 0.270982, 0.0121094, -0.159927, 0.946336},
-     }},
+     }}},
     {20,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.38, 0.924986, 0, 0, 0, 0},
          {0.52, 0.473088, 0.711188, 0, 0, 0},
          {0, 0.367573, -0.0617198, 0.927944, 0, 0},
          {-0.04, 0.68628, 0.149228, 0.115257, 0.701332, 0},
          {-0.16, -0.0441088, 0.118207, 0.251641, -0.0752458, 0.943131},
-     }},
+     }}},
     {30,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.42, 0.907524, 0, 0, 0, 0},
          {0.54, 0.48131, 0.690464, 0, 0, 0},
          {0, 0.363627, -0.137613, 0.921324, 0, 0},
          {-0.04, 0.686704, 0.117433, 0.104693, 0.708581, 0},
          {-0.19, -0.0438556, 0.0922685, 0.269877, -0.136292, 0.928469},
-     }},
+     }}},
     {40,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.36, 0.932952, 0, 0, 0, 0},
          {0.53, 0.483197, 0.696865, 0, 0, 0},
          {0.01, 0.464761, -0.0285153, 0.88492, 0, 0},
          {-0.05, 0.763169, 0.140255, 0.0562856, 0.626286, 0},
          {-0.16, -0.126051, 0.0942905, 0.195354, -0.217188, 0.92967},
-     }},
+     }}},
     {50,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.39, 0.920815, 0, 0, 0, 0},
          {0.55, 0.406705, 0.729446, 0, 0, 0},
          {0.01, 0.503793, -0.123923, 0.854831, 0, 0},
          {-0.06, 0.821664, -0.207246, 0.0245302, 0.526988, 0},
          {-0.19, -0.254231, 0.10679, 0.190931, -0.0665276, 0.920316},
-     }},
+     }}},
     {60,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.42, 0.907524, 0, 0, 0, 0},
          {0.56, 0.391395, 0.730213, 0, 0, 0},
          {0.02, 0.427978, -0.0393147, 0.902712, 0, 0},
          {-0.06, 0.820694, -0.119986, 0.105509, 0.545281, 0},
          {-0.2, -0.279882, 0.180145, 0.0563477, -0.0121631, 0.919723},
-     }},
+     }}},
     {70,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.36, 0.932952, 0, 0, 0, 0},
          {0.54, 0.519212, 0.662434, 0, 0, 0},
          {0.04, 0.412025, -0.0234416, 0.909992, 0, 0},
          {-0.09, 0.758452, -0.0682296, 0.0214276, 0.64151, 0},
          {-0.17, -0.387158, 0.306169, -0.0291255, -0.109344, 0.845378},
-     }},
+     }}},
     {80,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.44, 0.897998, 0, 0, 0, 0},
          {0.57, 0.43519, 0.696928, 0, 0, 0},
          {0.01, 0.316705, -0.248988, 0.915207, 0, 0},
          {-0.06, 0.805793, -0.296262, -0.0419182, 0.507514, 0},
          {-0.22, -0.497551, 0.289742, 0.0785823, 0.328773, 0.711214},
-     }},
+     }}},
     {90,
-     {
+     {{
          {1, 0, 0, 0, 0, 0},
          {-0.27, 0.96286, 0, 0, 0, 0},
          {0.46, 0.741748, 0.488067, 0, 0, 0},
          {0.04, 0.0735309, -0.374828, 0.923308, 0, 0},
          {-0.08, 0.517624, 0.128779, 0.0795063, 0.838308, 0},
          {-0.11, -0.321646, 0.0802763, -0.131981, -0.193429, 0.907285},
-     }},
+     }}},
 };
 
 /**
@@ -673,7 +662,7 @@
  * the quantized elevation angle.
  * The inner vector collects the table3gpp values.
  */
-static const std::map<std::string, std::map<int, std::vector<float>>> NTNDenseUrbanLOS{
+static const std::map<std::string, std::map<int, std::array<float, 22>>> NTNDenseUrbanLOS{
     {"S",
      {
          {10, {-7.12, 0.8, -3.06, 0.48, 0.94, 0.7,  0.82, 0.03, -2.52, 0.5, 4.4,
@@ -724,7 +713,7 @@
  * the quantized elevation angle.
  * The inner vector collects the table3gpp values.
  */
-static const std::map<std::string, std::map<int, std::vector<float>>> NTNDenseUrbanNLOS{
+static const std::map<std::string, std::map<int, std::array<float, 20>>> NTNDenseUrbanNLOS{
     {"S",
      {
          {10, {-6.84, 0.82, -2.08, 0.87, 1.0,  1.6, 1.0, 0.63, -2.08, 0.58,
@@ -775,7 +764,7 @@
  * the quantized elevation angle.
  * The inner vector collects the table3gpp values.
  */
-static const std::map<std::string, std::map<int, std::vector<float>>> NTNUrbanLOS{
+static const std::map<std::string, std::map<int, std::array<float, 22>>> NTNUrbanLOS{
     {"S",
      {
          {10, {-7.97, 1.0, -2.6, 0.79, 0.18, 0.74, -0.63, 2.6,  -2.54, 2.62, 31.83,
@@ -826,7 +815,7 @@
  * the quantized elevation angle.
  * The inner vector collects the table3gpp values.
  */
-static const std::map<std::string, std::map<int, std::vector<float>>> NTNUrbanNLOS{
+static const std::map<std::string, std::map<int, std::array<float, 22>>> NTNUrbanNLOS{
     {"S",
      {
          {10, {-7.24, 1.26, -1.58, 0.89, 0.13, 2.99, -1.13, 2.66, -2.87, 2.76, 0.0,
@@ -877,7 +866,7 @@
  * the quantized elevation angle.
  * The inner vector collects the table3gpp values.
  */
-static const std::map<std::string, std::map<int, std::vector<float>>> NTNSuburbanLOS{
+static const std::map<std::string, std::map<int, std::array<float, 22>>> NTNSuburbanLOS{
     {"S",
      {
          {10, {-8.16, 0.99, -3.57, 1.62, 0.05, 1.84, -1.78, 0.62, -1.06, 0.96, 11.4,
@@ -928,7 +917,7 @@
  * the quantized elevation angle.
  * The inner vector collects the table3gpp values.
  */
-static const std::map<std::string, std::map<int, std::vector<float>>> NTNSuburbanNLOS{
+static const std::map<std::string, std::map<int, std::array<float, 22>>> NTNSuburbanNLOS{
     {"S",
      {
          {10, {-7.43, 0.5, -2.89, 0.41, 1.49, 0.4,  0.81, 0.36, -3.09, 0.32, 0.0,
@@ -979,7 +968,7 @@
  * the quantized elevation angle.
  * The inner vector collects the table3gpp values.
  */
-static const std::map<std::string, std::map<int, std::vector<float>>> NTNRuralLOS{
+static const std::map<std::string, std::map<int, std::array<float, 22>>> NTNRuralLOS{
     {"S",
      {
          {10, {-9.55, 0.66, -3.42, 0.89, -9.45, 7.83, -4.2, 6.3,  -6.03, 5.19, 24.72,
@@ -1030,7 +1019,7 @@
  * the quantized elevation angle.
  * The inner vector collects the table3gpp values.
  */
-static const std::map<std::string, std::map<int, std::vector<float>>> NTNRuralNLOS{
+static const std::map<std::string, std::map<int, std::array<float, 22>>> NTNRuralNLOS{
     {"S",
      {
          {10, {-9.01, 1.59, -2.9, 1.34, -3.33, 6.22, -0.88, 3.26, -4.92, 3.96, 0.0,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/spectrum/model/three-gpp-channel-model.h ns-3.43/src/spectrum/model/three-gpp-channel-model.h
--- ns-3.42/src/spectrum/model/three-gpp-channel-model.h	2024-05-29 15:29:47.172073600 -0700
+++ ns-3.43/src/spectrum/model/three-gpp-channel-model.h	2024-10-09 16:41:10.088656700 -0700
@@ -4,18 +4,7 @@
  * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
  * University of Padova
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #ifndef THREE_GPP_CHANNEL_H
@@ -251,8 +240,6 @@
      * \param hUT the height of the UT
      * \param distance2D the 2D distance between tx and rx
      * \return the parameters table
-     * \deprecated Use GetThreeGppTable(const Ptr<const MobilityModel> aMob, const Ptr<const
-     *  MobilityModel> bMob, Ptr<const ChannelCondition> channelCondition) instead
      */
     NS_DEPRECATED_3_41("Use GetThreeGppTable(const Ptr<const MobilityModel>, const Ptr<const "
                        "MobilityModel>, Ptr<const ChannelCondition>) instead")
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc ns-3.43/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc
--- ns-3.42/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2024-05-29 15:29:47.172073600 -0700
+++ ns-3.43/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.cc	2024-10-09 16:41:10.088656700 -0700
@@ -4,18 +4,7 @@
  * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
  * University of Padova
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  */
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h ns-3.43/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h
--- ns-3.42/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2024-05-29 15:29:47.172073600 -0700
+++ ns-3.43/src/spectrum/model/three-gpp-spectrum-propagation-loss-model.h	2024-10-09 16:41:10.088656700 -0700
@@ -4,18 +4,7 @@
  * Copyright (c) 2019 SIGNET Lab, Department of Information Engineering,
  * University of Padova
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  */
 
 #ifndef THREE_GPP_SPECTRUM_PROPAGATION_LOSS_H
